--- old/usr/src/uts/common/vm/seg_kp.c	2015-05-08 18:10:35.736191120 -0400
+++ new/usr/src/uts/common/vm/seg_kp.c	2015-05-08 18:10:35.742963823 -0400
@@ -75,7 +75,6 @@
 /*
  * Private seg op routines
  */
-static void	segkp_badop(void);
 static void	segkp_dump(struct seg *seg);
 static int	segkp_checkprot(struct seg *seg, caddr_t addr, size_t len,
 			uint_t prot);
@@ -94,10 +93,6 @@
 static int	segkp_load(struct hat *hat, struct seg *seg, caddr_t vaddr,
 			size_t len, struct segkp_data *kpd, uint_t flags);
 static struct	segkp_data *segkp_find(struct seg *seg, caddr_t vaddr);
-static int	segkp_getmemid(struct seg *seg, caddr_t addr, memid_t *memidp);
-static lgrp_mem_policy_info_t	*segkp_getpolicy(struct seg *seg,
-    caddr_t addr);
-static int	segkp_capable(struct seg *seg, segcapability_t capability);
 
 /*
  * Lock used to protect the hash table(s) and caches.
@@ -109,8 +104,6 @@
  */
 static struct segkp_cache segkp_cache[SEGKP_MAX_CACHE];
 
-#define	SEGKP_BADOP(t)	(t(*)())segkp_badop
-
 /*
  * When there are fewer than red_minavail bytes left on the stack,
  * segkp_map_red() will map in the redzone (if called).  5000 seems
@@ -145,41 +138,15 @@
 pgcnt_t anon_segkp_pages_locked;	/* See vm/anon.h */
 pgcnt_t anon_segkp_pages_resv;		/* anon reserved by seg_kp */
 
-static struct	seg_ops segkp_ops = {
-	SEGKP_BADOP(int),		/* dup */
-	SEGKP_BADOP(int),		/* unmap */
-	SEGKP_BADOP(void),		/* free */
-	segkp_fault,
-	SEGKP_BADOP(faultcode_t),	/* faulta */
-	SEGKP_BADOP(int),		/* setprot */
-	segkp_checkprot,
-	segkp_kluster,
-	SEGKP_BADOP(size_t),		/* swapout */
-	SEGKP_BADOP(int),		/* sync */
-	SEGKP_BADOP(size_t),		/* incore */
-	SEGKP_BADOP(int),		/* lockop */
-	SEGKP_BADOP(int),		/* getprot */
-	SEGKP_BADOP(u_offset_t),		/* getoffset */
-	SEGKP_BADOP(int),		/* gettype */
-	SEGKP_BADOP(int),		/* getvp */
-	SEGKP_BADOP(int),		/* advise */
-	segkp_dump,			/* dump */
-	segkp_pagelock,			/* pagelock */
-	SEGKP_BADOP(int),		/* setpgsz */
-	segkp_getmemid,			/* getmemid */
-	segkp_getpolicy,		/* getpolicy */
-	segkp_capable,			/* capable */
-	seg_inherit_notsup		/* inherit */
+static const struct seg_ops segkp_ops = {
+	.fault		= segkp_fault,
+	.checkprot	= segkp_checkprot,
+	.kluster	= segkp_kluster,
+	.dump		= segkp_dump,
+	.pagelock	= segkp_pagelock,
 };
 
 
-static void
-segkp_badop(void)
-{
-	panic("segkp_badop");
-	/*NOTREACHED*/
-}
-
 static void segkpinit_mem_config(struct seg *);
 
 static uint32_t segkp_indel;
@@ -760,15 +727,11 @@
  * stack base.  If the amount of stack remaining is questionable
  * (less than red_minavail), then segkp_map_red() will map in the redzone
  * and return 1.  Otherwise, it will return 0.  segkp_map_red() can
- * _only_ be called when:
- *
- *   - it is safe to sleep on page_create_va().
- *   - the caller is non-swappable.
+ * _only_ be called when it is safe to sleep on page_create_va().
  *
  * It is up to the caller to remember whether segkp_map_red() successfully
  * mapped the redzone, and, if so, to call segkp_unmap_red() at a later
- * time.  Note that the caller must _remain_ non-swappable until after
- * calling segkp_unmap_red().
+ * time.
  *
  * Currently, this routine is only called from pagefault() (which necessarily
  * satisfies the above conditions).
@@ -782,8 +745,6 @@
 	caddr_t stkbase;
 #endif
 
-	ASSERT(curthread->t_schedflag & TS_DONT_SWAP);
-
 	/*
 	 * Optimize for the common case where we simply return.
 	 */
@@ -884,7 +845,6 @@
 	    (uintptr_t)PAGEMASK) - PAGESIZE);
 
 	ASSERT(curthread->t_red_pp != NULL);
-	ASSERT(curthread->t_schedflag & TS_DONT_SWAP);
 
 	/*
 	 * Because we locked the mapping down, we can't simply rely
@@ -1399,27 +1359,6 @@
 	return (ENOTSUP);
 }
 
-/*ARGSUSED*/
-static int
-segkp_getmemid(struct seg *seg, caddr_t addr, memid_t *memidp)
-{
-	return (ENODEV);
-}
-
-/*ARGSUSED*/
-static lgrp_mem_policy_info_t	*
-segkp_getpolicy(struct seg *seg, caddr_t addr)
-{
-	return (NULL);
-}
-
-/*ARGSUSED*/
-static int
-segkp_capable(struct seg *seg, segcapability_t capability)
-{
-	return (0);
-}
-
 #include <sys/mem_config.h>
 
 /*ARGSUSED*/
